diff --git a/package/base-files/files/etc/preinit b/package/base-files/files/etc/preinit
index 0fdfa8cf886d24b4ae4f25ffd7317477522a0561..b237c2e06ebee0a34487b7538bc3a54dc106fda2 100755
--- a/package/base-files/files/etc/preinit
+++ b/package/base-files/files/etc/preinit
@@ -22,7 +22,6 @@ pi_init_path="/bin:/sbin:/usr/bin:/usr/sbin"
 pi_init_cmd="/sbin/init"
 
 . /lib/functions.sh
-. /lib/functions/boot.sh
 
 boot_hook_init preinit_essential
 boot_hook_init preinit_main
diff --git a/package/base-files/files/lib/functions.sh b/package/base-files/files/lib/functions.sh
index db59706bc5aeb2db958395edfad7bbc989fa93ae..54e69b8332a23372d7298106e509fdf696a4d735 100755
--- a/package/base-files/files/lib/functions.sh
+++ b/package/base-files/files/lib/functions.sh
@@ -348,4 +348,141 @@ pi_include() {
 	return 0
 }
 
+#!/bin/sh
+# Copyright (C) 2006-2010 OpenWrt.org
+# Copyright (C) 2010 Vertical Communications
+
+boot_hook_splice_start() {
+	export -n PI_HOOK_SPLICE=1
+}
+
+boot_hook_splice_finish() {
+	local hook
+	for hook in $PI_STACK_LIST; do
+		local v; eval "v=\${${hook}_splice:+\$${hook}_splice }$hook"
+		export -n "${hook}=${v% }"
+		export -n "${hook}_splice="
+	done
+	export -n PI_HOOK_SPLICE=
+}
+
+boot_hook_init() {
+	local hook="${1}_hook"
+	export -n "PI_STACK_LIST=${PI_STACK_LIST:+$PI_STACK_LIST }$hook"
+	export -n "$hook="
+}
+
+boot_hook_add() {
+	local hook="${1}_hook${PI_HOOK_SPLICE:+_splice}"
+	local func="${2}"
+
+	[ -n "$func" ] && {
+		local v; eval "v=\$$hook"
+		export -n "$hook=${v:+$v }$func"
+	}
+}
+
+boot_hook_shift() {
+	local hook="${1}_hook"
+	local rvar="${2}"
+
+	local v; eval "v=\$$hook"
+	[ -n "$v" ] && {
+		local first="${v%% *}"
+
+		[ "$v" != "${v#* }" ] && \
+			export -n "$hook=${v#* }" || \
+			export -n "$hook="
+
+		export -n "$rvar=$first"
+		return 0
+	}
+
+	return 1
+}
+
+boot_run_hook() {
+	local hook="$1"
+	local func
+
+	while boot_hook_shift "$hook" func; do
+		local ran; eval "ran=\$PI_RAN_$func"
+		[ -n "$ran" ] || {
+			export -n "PI_RAN_$func=1"
+			$func "$1" "$2"
+		}
+	done
+}
+
+jffs2_ready () {
+	mtdpart="$(find_mtd_part rootfs_data)"
+	[ -z "$mtdpart" ] && return 1
+	magic=$(hexdump $mtdpart -n 4 -e '4/1 "%02x"')
+	[ "$magic" != "deadc0de" ]
+}
+
+dupe() { # <new_root> <old_root>
+	cd $1
+	echo -n "creating directories... "
+	{
+		cd $2
+		find . -xdev -type d
+		echo "./dev ./overlay ./mnt ./proc ./tmp"
+		# xdev skips mounted directories
+		cd $1
+	} | xargs mkdir -p
+	echo "done"
+
+	echo -n "setting up symlinks... "
+	for file in $(cd $2; find . -xdev -type f;); do
+		case "$file" in
+		./rom/note) ;; #nothing
+		./etc/config*|\
+		./usr/lib/opkg/info/*) cp -af $2/$file $file;;
+		*) ln -sf /rom/${file#./*} $file;;
+		esac
+	done
+	for file in $(cd $2; find . -xdev -type l;); do
+		cp -af $2/${file#./*} $file
+	done
+	echo "done"
+}
+
+pivot() { # <new_root> <old_root>
+	mount -o noatime,move /proc $1/proc && \
+	pivot_root $1 $1$2 && {
+		mount -o noatime,move $2/dev /dev
+		mount -o noatime,move $2/tmp /tmp
+		mount -o noatime,move $2/sys /sys 2>&-
+		mount -o noatime,move $2/overlay /overlay 2>&-
+		return 0
+	}
+}
+
+fopivot() { # <rw_root> <ro_root> <dupe?>
+	root=$1
+	{
+		if grep -q overlay /proc/filesystems; then
+			mount -o noatime,lowerdir=/,upperdir=$1 -t overlayfs "overlayfs:$1" /mnt && root=/mnt
+		elif grep -q mini_fo /proc/filesystems; then
+			mount -t mini_fo -o noatime,base=/,sto=$1 "mini_fo:$1" /mnt 2>&- && root=/mnt
+		else
+			mount --bind -o noatime / /mnt
+			mount --bind -o noatime,union "$1" /mnt && root=/mnt
+		fi
+	} || {
+		[ "$3" = "1" ] && {
+		mount | grep "on $1 type" 2>&- 1>&- || mount -o noatime,bind $1 $1
+		dupe $1 $rom
+		}
+	}
+	pivot $root $2
+}
+
+ramoverlay() {
+	mkdir -p /tmp/root
+	mount -t tmpfs -o noatime,mode=0755 root /tmp/root
+	fopivot /tmp/root /rom 1
+}
+
 [ -z "$IPKG_INSTROOT" -a -f /lib/config/uci.sh ] && . /lib/config/uci.sh
diff --git a/package/base-files/files/lib/functions/boot.sh b/package/base-files/files/lib/functions/boot.sh
deleted file mode 100644
index 137c3bf476525b7730150925bd2a6b37e420af6e..0000000000000000000000000000000000000000
--- a/package/base-files/files/lib/functions/boot.sh
+++ /dev/null
@@ -1,146 +0,0 @@
-#!/bin/sh
-# Copyright (C) 2006-2010 OpenWrt.org
-# Copyright (C) 2010 Vertical Communications
-
-boot_hook_splice_start() {
-	export -n PI_HOOK_SPLICE=1
-}
-
-boot_hook_splice_finish() {
-	local hook
-	for hook in $PI_STACK_LIST; do
-		local v; eval "v=\${${hook}_splice:+\$${hook}_splice }$hook"
-		export -n "${hook}=${v% }"
-		export -n "${hook}_splice="
-	done
-	export -n PI_HOOK_SPLICE=
-}
-
-boot_hook_init() {
-	local hook="${1}_hook"
-	export -n "PI_STACK_LIST=${PI_STACK_LIST:+$PI_STACK_LIST }$hook"
-	export -n "$hook="
-}
-
-boot_hook_add() {
-	local hook="${1}_hook${PI_HOOK_SPLICE:+_splice}"
-	local func="${2}"
-
-	[ -n "$func" ] && {
-		local v; eval "v=\$$hook"
-		export -n "$hook=${v:+$v }$func"
-	}
-}
-
-boot_hook_shift() {
-	local hook="${1}_hook"
-	local rvar="${2}"
-
-	local v; eval "v=\$$hook"
-	[ -n "$v" ] && {
-		local first="${v%% *}"
-
-		[ "$v" != "${v#* }" ] && \
-			export -n "$hook=${v#* }" || \
-			export -n "$hook="
-
-		export -n "$rvar=$first"
-		return 0
-	}
-
-	return 1
-}
-
-boot_run_hook() {
-	local hook="$1"
-	local func
-
-	while boot_hook_shift "$hook" func; do
-		local ran; eval "ran=\$PI_RAN_$func"
-		[ -n "$ran" ] || {
-			export -n "PI_RAN_$func=1"
-			$func "$1" "$2"
-		}
-	done
-}
-
-find_mtd_part() {
-	local PART="$(grep "\"$1\"" /proc/mtd | awk -F: '{print $1}')"
-	local PREFIX=/dev/mtdblock
-
-	PART="${PART##mtd}"
-	[ -d /dev/mtdblock ] && PREFIX=/dev/mtdblock/
-	echo "${PART:+$PREFIX$PART}"
-}
-
-jffs2_ready () {
-	mtdpart="$(find_mtd_part rootfs_data)"
-	[ -z "$mtdpart" ] && return 1
-	magic=$(hexdump $mtdpart -n 4 -e '4/1 "%02x"')
-	[ "$magic" != "deadc0de" ]
-}
-
-dupe() { # <new_root> <old_root>
-	cd $1
-	echo -n "creating directories... "
-	{
-		cd $2
-		find . -xdev -type d
-		echo "./dev ./overlay ./mnt ./proc ./tmp"
-		# xdev skips mounted directories
-		cd $1
-	} | xargs mkdir -p
-	echo "done"
-
-	echo -n "setting up symlinks... "
-	for file in $(cd $2; find . -xdev -type f;); do
-		case "$file" in
-		./rom/note) ;; #nothing
-		./etc/config*|\
-		./usr/lib/opkg/info/*) cp -af $2/$file $file;;
-		*) ln -sf /rom/${file#./*} $file;;
-		esac
-	done
-	for file in $(cd $2; find . -xdev -type l;); do
-		cp -af $2/${file#./*} $file
-	done
-	echo "done"
-}
-
-pivot() { # <new_root> <old_root>
-	mount -o noatime,move /proc $1/proc && \
-	pivot_root $1 $1$2 && {
-		mount -o noatime,move $2/dev /dev
-		mount -o noatime,move $2/tmp /tmp
-		mount -o noatime,move $2/sys /sys 2>&-
-		mount -o noatime,move $2/overlay /overlay 2>&-
-		return 0
-	}
-}
-
-fopivot() { # <rw_root> <ro_root> <dupe?>
-	root=$1
-	{
-		if grep -q overlay /proc/filesystems; then
-			mount -o noatime,lowerdir=/,upperdir=$1 -t overlayfs "overlayfs:$1" /mnt && root=/mnt
-		elif grep -q mini_fo /proc/filesystems; then
-			mount -t mini_fo -o noatime,base=/,sto=$1 "mini_fo:$1" /mnt 2>&- && root=/mnt
-		else
-			mount --bind -o noatime / /mnt
-			mount --bind -o noatime,union "$1" /mnt && root=/mnt
-		fi
-	} || {
-		[ "$3" = "1" ] && {
-		mount | grep "on $1 type" 2>&- 1>&- || mount -o noatime,bind $1 $1
-		dupe $1 $rom
-		}
-	}
-	pivot $root $2
-}
-
-ramoverlay() {
-	mkdir -p /tmp/root
-	mount -t tmpfs -o noatime,mode=0755 root /tmp/root
-	fopivot /tmp/root /rom 1
-}
-
diff --git a/package/base-files/files/sbin/firstboot b/package/base-files/files/sbin/firstboot
index 8fbd4999021927e337279867c174d39af68fef74..7e9731b00a0e2c7d7d6061f098679b636d1b89f0 100755
--- a/package/base-files/files/sbin/firstboot
+++ b/package/base-files/files/sbin/firstboot
@@ -4,7 +4,7 @@ switch2jffs_hook=
 jffs2reset_hook=
 no_fo_hook=
 
-. /lib/functions/boot.sh
+. /lib/functions.sh
 
 firstboot_skip_next=false
 
diff --git a/package/base-files/files/sbin/mount_root b/package/base-files/files/sbin/mount_root
index 2d73dac53f2a29a6225a1b3581d7aa088c8668ec..1c48ebab1eb0426651bbcea1dc784b393786d6fa 100755
--- a/package/base-files/files/sbin/mount_root
+++ b/package/base-files/files/sbin/mount_root
@@ -10,7 +10,7 @@ failsafe_hook=
 initramfs_hook=
 preinit_mount_root=
 
-. /lib/functions/boot.sh
+. /lib/functions.sh
 
 for pi_source_file in /lib/preinit/*; do
     . $pi_source_file
diff --git a/target/linux/ep93xx/base-files/lib/preinit/05_set_ether_mac_rdc b/target/linux/ep93xx/base-files/lib/preinit/05_set_ether_mac_rdc
index 948ed74c3510d83c9f03e4061eb3961f6b170b75..9e5d09fd1331fedf2f8bd7cc5056b6c1c3fd9e78 100644
--- a/target/linux/ep93xx/base-files/lib/preinit/05_set_ether_mac_rdc
+++ b/target/linux/ep93xx/base-files/lib/preinit/05_set_ether_mac_rdc
@@ -1,7 +1,7 @@
 #!/bin/sh
 # Copyright (C) 2010 OpenWrt.org
 
-. /lib/functions/boot.sh
+. /lib/functions.sh
 
 set_ether_mac() {
 	mac=$(sed -n 's/^Serial.* 000000/02/p' /proc/cpuinfo)
diff --git a/target/linux/x86/rdc/base-files/lib/preinit/05_set_ether_mac_rdc b/target/linux/x86/rdc/base-files/lib/preinit/05_set_ether_mac_rdc
index 4640e008faf1535e70ddeb74686ff8f2c473860f..0518766a78ca1365393d178865a1d5e07396db5f 100644
--- a/target/linux/x86/rdc/base-files/lib/preinit/05_set_ether_mac_rdc
+++ b/target/linux/x86/rdc/base-files/lib/preinit/05_set_ether_mac_rdc
@@ -1,7 +1,7 @@
 #!/bin/sh
 # Copyright (C) 2009-2012 OpenWrt.org
 
-. /lib/functions/boot.sh
+. /lib/functions.sh
 
 r6040_module() {
 	insmod libphy